/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelUserInfo = {};
panelUserInfo.localization = {};
/****************************/

// Panel details
panelUserInfo.panelName = "UserInfo";
panelUserInfo._panel = $("#pnl" + panelUserInfo.panelName);

// Localizations
panelUserInfo.localization = {
};

// Assign localizations
localizations.panels[panelUserInfo.panelName] = $.extend(panelUserInfo.localization, localizations.panels[panelUserInfo.panelName]);

// Interface methods
panelUserInfo.init = function(){
	applyLocalizations(panelUserInfo.panelName, localizations.panels);
	panelUserInfo.bindEvents();
	panelUserInfo.resizeInfoContent();
	panelUserInfo.showHidePanels();
}

panelUserInfo.showHidePanels = function(flag)
{
	if(flag)
	{
		$("#userInfoContentPanel", panelUserInfo._panel).show();
		$("#userInfoContentTip", panelUserInfo._panel).hide();
	}
	else
	{
		$("#userInfoContentPanel", panelUserInfo._panel).hide();
		$("#userInfoContentTip", panelUserInfo._panel).show();
	}
}

panelUserInfo.resizeInfoContent = function()
{
	var userInfoContent = $("#userInfoContent", panelUserInfo._panel);
	var sideBar = $(".sideBar", panelUserInfo._panel);
	var windowWidth = $(window).width();
	windowWidth = windowWidth - sideBar.width() - 100;
	windowWidth = windowWidth < 300 ? 300 : windowWidth;
	userInfoContent.width(windowWidth);
}

panelUserInfo.status = {
	logLiveUpdate : function()
	{
		return $("#user_log_live_update", panelUserInfo._panel).is(":checked") || $("#user_log", panelUserInfo._panel).text() == "";
	},
	logScrollWithActivity : function()
	{
		return $("#user_log_scroll_with_activity", panelUserInfo._panel).is(":checked");
	},
	selectedSession : function()
	{
		var sessionInfo = false;
		var sel = $("#lst_sessions", panelUserInfo._panel).find(":selected:first");
		if(sel.length>0)
		{
			sessionInfo = {
				type : "",
				index : sel.index()
			};
		}
		else
		{
			sel = $("#lst_recent_sessions", panelUserInfo._panel).find(":selected:first");
			if(sel.length>0)
			{
				sessionInfo = {
					type : "recent_",
					index : sel.index()
				};
			}
		}
		return sessionInfo;
	}
};

// Bind data from provided JSON to panel's fields
panelUserInfo.bindData  = {
	sessionList : function(data, prefix, elem, selection){
		prefix = prefix || "";
		if(!data)
		{
			return;
		}
		elem = elem || $("#lst_"+prefix+"sessions", panelUserInfo._panel);
		var selectedItems = [];
		elem.find("option:selected").each(function(){
			selectedItems.push($(this).val());
		});
		if(elem && elem.length>0)
		{
			adminPanel.UI.multiOptionControlDataBind(data
				, "session_list"
				, elem
				, function(curItem){
					var user_name = unescape(curItem.user_name);
					var user_number = unescape(curItem.user_number);
					var user_ip = unescape(curItem.user_ip);
					var user_protocol = unescape(curItem.user_protocol);
					if(typeof user_name != "undefined" && user_name != "undefined")
					{
						return $("<option value='"+ user_number +"'>"+ user_number+"-"+user_name+"@"+user_protocol+":"+user_ip +"</option>");
					}
					else
					{
						return false;
					}
				}
				, true
			);
			if(selection && selection.index>=0)
			{
				if(selection.type == prefix)
				{
					panelUserInfo.showHidePanels(selection.index>=0);
					var index = selection.index + 1;
					var loaded = elem.find("option:nth-child("+index+")").prepend(" -> ");
					if(selectedItems.length == 1)
					{
						loaded.attr("selected", "selected");
					}
					else
					{
						for(var i=0;i<selectedItems.length;i++)
						{
							elem.find("option[value='"+selectedItems[i]+"']").attr("selected", "selected");
						}
					}
					if(loaded.length==0)
					{
						panelUserInfo.showHidePanels(false);
					}
				}
			}
			else
				panelUserInfo.showHidePanels(false);
		}
	},
	sessionInfo : function(data, selection, elem){
		if(!data)
		{
			return;
		}
		$("#sessionInfoPanel", panelUserInfo._panel).find(".liveData").text("");
		$("#user_log", panelUserInfo._panel).text("");
		var items = $.xml2json(data);
		adminPanel.methods.rebuildSubItems(items, "result_value");
		if(panelUserInfo.status.logLiveUpdate())
		{
			if(data.getElementsByTagName("user_log").length>0)
			{
				var log = [];
				$(data).find("user_log_subitem").each(function(){
					log.push($(this).text());
				});
				if(adminPanel.buggyBrowser)
					panelUserInfo.bindData.serverLog(log.join("\r\n"));
				else
					panelUserInfo.bindData.serverLog(log.join("\n"));
			}
		}

		elem = elem || $("#sessionInfoPanel", panelUserInfo._panel);
		if(elem && elem.length>0)
		{
			adminPanel.data.bindValuesFromJson(elem, items);
		}
		$("#curSelection", panelUserInfo._panel).val(selection.type + "" + selection.index);
		elem.find(".formatData, .hideZero, .formatTime").each(function(){
			var val = $(this).text();
			if($(this).hasClass("hideZero"))
			{
				val = adminPanel.methods.hideZero(val);
				$(this).text(val);
			}
			if($(this).hasClass("formatData"))
			{
				if(val && adminPanel.methods.isNumeric(val))
				{
					if($(this).hasClass("inKBs"))
					{
						val = parseFloat(val) * 1024;
					}
					$(this).text(adminPanel.methods.formatBytes(val));
					if($(this).hasClass("speedInSecond"))
					{
						$(this).text($(this).text() + " /sec");
					}
				}
			}
			if($(this).hasClass("formatTime"))
			{
				if(val && adminPanel.methods.isNumeric(val))
				{
					$(this).text(adminPanel.methods.formatTime(Math.abs(val).toString()));
				}
			}
		});
	},
	serverLog : function(data, scroll, elem)
	{
		if(!data)
		{
			return;
		}
		elem = elem || $("#user_log", panelUserInfo._panel);
		if(elem && elem.length>0)
		{
			elem.text(data);
			var now = new Date();
			$("#lastUserLogUpdatedTimestamp", panelUserInfo._panel).text(dateFormat(now, "mediumTime"));
		}
		scroll = scroll || panelUserInfo.status.logScrollWithActivity();
		if(scroll)
		{
			elem.attr("scrollTop", elem.attr("scrollHeight"));
		}
	}
}

panelUserInfo.adminAction = function(action, selection, banTimeout)
{
	if(!action || !selection) return;
	var selectedItems = [];
	selection.each(function(){
		selectedItems.push($(this).val());
	});
	var cmdObj = {
		command: "adminAction",
		action : action,
		index : selectedItems.join(",")
	};
	if(banTimeout)
	{
		cmdObj.banTimeout = banTimeout;
	}
	adminPanel.data.serverRequest(
	cmdObj,
	function(data){
		var success = false;
		if(data)
		{
			var usersData = $.xml2json(data);
			if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
			{
				success = true;
			}
		}
		if(!success)
		{
			adminPanel.UI.growl("Failure", "Admin action " + action + " failed for index " + cmdObj.index, true, true);
		}
		else
		{
			adminPanel.UI.growl("Sucess", "Admin action " + action + " completed for index " + cmdObj.index, false, 1500);
		}
	});
}

panelUserInfo.sessionSelected = function(list, index)
{
	if(list.is("#lst_sessions"))
	{
		$("#lst_recent_sessions", panelUserInfo._panel).find(":selected").removeAttr("selected");
		if($("#curSelection", panelUserInfo._panel).val() != "" + index)
		{
			$("#user_log", panelUserInfo._panel).text("");
		}
	}
	else
	{
		$("#lst_sessions", panelUserInfo._panel).find(":selected").removeAttr("selected");
		if($("#curSelection", panelUserInfo._panel).val() != "recent_" + index)
		{
			$("#user_log", panelUserInfo._panel).text("");
		}
	}
	$("#sessionInfoPanel", panelUserInfo._panel).find(".liveData").text("");
	$("#user_log", panelUserInfo._panel).text("");
	adminPanel.data.dataRefreshCall();
}

panelUserInfo.bindEvents = function()
{
	$(window).resize(function () {
		panelUserInfo.resizeInfoContent();
	});

	$("#lst_sessions, #lst_recent_sessions", panelUserInfo._panel).unbind("change").bind("change"
	, function(){
		if($(this).find(":selected").length==1)
		{
			panelUserInfo.sessionSelected($(this), $(this).find(":selected:first").index());
		}
	});

	$("#actionButtons", panelUserInfo._panel).find("a.sessionAction").click(function(){
		var action = $(this).attr("_action");
		var selection = $("#lst_sessions, #lst_recent_sessions", panelUserInfo._panel).find(":selected");
		if(selection && selection.length>0)
		{
			var showAction = action;
			if(showAction == "temporaryBan")
				showAction = "temporarily ban";
			else if(showAction == "ban")
				showAction = "permanently ban";

			if(action == "temporaryBan")
			{
				var benTimeout = 10;
				function getMinutes(val, callback)
				{
					val = val || benTimeout;
					jPrompt("For how many minutes do you want to Ban selected user(s)?", val, "Temporary Ban", function(value){
						if(value)
						{
							value = $.trim(value);
							if(value && adminPanel.methods.isNumeric(value))
							{
								if(callback)
									callback(value);
							}
							else
							{
								jAlert("Please enter only numeric value for minutes", "Error", function(){
									getMinutes(value, callback);
								});
							}
						}
					});
				}
				getMinutes(false, function(minutes){
					panelUserInfo.adminAction(action, selection, minutes);
				});
			}
			else
			{
				jConfirm("Are you sure you wish to <strong>" + showAction + "</strong>  selected user(s)?", "Confirm", function(flag){
					if(flag)
					{
						panelUserInfo.adminAction(action, selection);
					}
				});
			}
		}
		return false;
	});

	$("#user_log_refresh", panelUserInfo._panel).unbind("click").click(function(){
		$("#user_log", panelUserInfo._panel).text("");
		adminPanel.data.dataRefreshCall();
		return false;
	});
}